<template>
	<view class="lists">
		<view class="status_bar" :style="navHeight"></view>
		<view class="header-bg">
			<image class="header-bg-img" src="@/static/image/nav_bg@3x.png" mode="scaleToFill"></image>
		</view>
		<view class="main">
			<view class="middle view">
				<view class="text-block">
					<text class="middle-date">商机名称</text>
					<input class="middle-date-des" type="text" v-model="condition.BUNAME" placeholder="请填写" />
				</view>
				<view class="text-block">
					<text class="middle-date">商机所有人</text>
					<input class="middle-date-des" type="text" v-model="condition.OWNERCODE" placeholder="请填写" />
				</view>
				<view class="text-block text-block-last" @click="selectGroupClient">
					<text class="middle-date">团购单位名称</text>
					<view class="middle-date-des uni-list picker-year">
						<view class="uni-list-cell">
							<view class="uni-list-cell-db">
								<text class="middle-date-des">{{selectedGroupClient.OBJNAME}}</text>
							</view>
						</view>
						<image class="icon-arrow" src="@/static/image/arrow_r@3x.png" mode="aspectFit"></image>
					</view>
				</view>
			</view>

			<view class="planout-block">
				<button class="btn" type="default" @tap="search">
					<text class="btn-text">查询</text>
				</button>
			</view>

			<scroll-view class="scroll-area" :style='scrollHeight' scroll-y="true" lower-threshold='150'
				@scrolltolower='scrolltolower'>
				<uni-swipe-action class="planout-block-lists">
					<uni-swipe-action-item v-for="(item,index) in lists" :key='item.ID' :auto-close="false"
						:disabled='true' :show="isOpened" @click="handleClick">
						<template v-slot:left>
							<view class="swipe-right-block" @click="handleChecked($event,item, index)"><text
									class="swipe-right-block__text"
									:class="{'swipe-right-block__active':item.checked}"></text>
							</view>
						</template>
						<view class="middle view planout-block-item">
							<view class="text-block">
								<text class="middle-date middle-date-select">商机编码</text>
								<text class="middle-date-des middle-date-des-select">{{item.ID}}</text>
							</view>
							<view class="text-block">
								<text class="middle-date middle-date-select">商机名称</text>
								<text class="middle-date-des middle-date-des-select">{{item.NAME}}</text>
							</view>
							<view class="text-block">
								<text class="middle-date middle-date-select">客户编号</text>
								<text class="middle-date-des middle-date-des-select">{{item.CUSTOMERCODE}}</text>
							</view>
							<view class="text-block text-block-last">
								<text class="middle-date middle-date-select">客户名称</text>
								<text class="middle-date-des middle-date-des-select">{{item.CUSTOMERNAME}}</text>
							</view>
						</view>

					</uni-swipe-action-item>
				</uni-swipe-action>
			</scroll-view>

		</view>
	</view>
</template>

<script>
	import {
		mapState
	} from 'vuex'

	import {
		apiBusinessSelect
	} from '@/servers/common.js'

	export default {
		data() {
			return {
				isOpened: 'none',
				condition: {
					BUNAME: '',
					OWNERCODE: '',
					CUNAME: ''
				},
				page: {
					"PAGE": "1",
					"PAGESIZE": "10",
				},
				loadParams: {
					total: 0,
					totalPage: 1,
					isDone: false,
					isRefresh: false
				},
				lists: [],
				selectedBusiness: {},
				selectedGroupClient: {},
				toPageParams: {
					page: ''
				}
			}
		},
		computed: {
			...mapState(['sysinfo']),
			navHeight() {
				return {
					'height': `${this.sysinfo.safeArea.top + 44}px`
				}
			},
			scrollHeight() {
				return {
					'height': `${this.sysinfo.safeArea.height - 297- 44 - 20}px`
				}
			}
		},
		onNavigationBarButtonTap(e) {
			// console.log('onNavigationBarButtonTap：', e, this.isOpened, this.selectedBusiness);
			if (this.isOpened === 'left' && this.selectedBusiness && this.selectedBusiness.ID) {
				uni.$emit('selectedBusiness', {
					selectedBusiness: this.selectedBusiness
				})
				uni.navigateBack({})
				return
			}
			this.isOpened = this.isOpened === 'none' ? 'left' : 'none';
			// #ifdef APP-PLUS  
			let pages = getCurrentPages()
			let page = pages[pages.length - 1]
			let webView = page.$getAppWebview();
			console.log('webView', webView)
			webView.setTitleNViewButtonStyle(0, {
				text: this.isOpened === 'none' ? '选择' : '完成',
			});
			// let titleObj = webView.getStyle().titleNView;
			//  if(!titleObj.buttons){
			// 	 returnl
			//  }
			//  titleObj.buttons[0].text = 'dd';
			//  webView.setStyle({
			// 	 titleNView:titleObj
			//  })
			// #endif
		},
		onLoad(option) {
			console.log('select-saleplan', option)
			if (option && option.from) {
				const {
					from
				} = option
				this.toPageParams.page = from
			}
		},
		onPullDownRefresh() {
			console.log('refresh');
			this.reset()
			this.getBusiness(true)
			setTimeout(function() {
				uni.stopPullDownRefresh();
			}, 600);
		},
		created() {
			this.reset()
			this.getBusiness(true);
		},
		mounted() {
			console.log('监听到事件来自 update');
			let _this = this
			uni.$once('selectedGroupClient', function(data) {
				console.log('监听到事件来自 selectedGroupClient ，携带参数 msg 为：', data);
				_this.selectedGroupClient = {
					...data.selectedGroupClient
				}
				_this.condition.CUNAME = data.selectedGroupClient.OBJNAME
			})
		},
		methods: {
			async getBusiness(isRefresh) {
				if (this.loadParams.isDone) {
					return
				}

				const {
					BUNAME,
					OWNERCODE,
					CUNAME
				} = this.condition
				const params = {
					...this.page,
					"input": {
						BUNAME: '',
						OWNERCODE: '',
						CUNAME: ''
					},
				}

				uni.showLoading({
					title: '加载中'
				});
				setTimeout(function() {
					uni.hideLoading();
				}, 2000);
				const res = await apiBusinessSelect(params)
				uni.hideLoading();

				const {
					DATA,
					TOTAL
				} = res
				this.loadParams.total = TOTAL
				this.loadParams.totalPage = Math.ceil(TOTAL * 1 / this.page.PAGESIZE * 1)

				const dataMap = res.DATA.map((item) => {
					item.checked = false
					return item
				})

				if (isRefresh) {
					this.lists = dataMap
					this.loadParams.isDone = false
				} else {
					this.lists = this.lists.concat(dataMap)
				}

			},
			scrolltolower() {
				console.log('onReachBottom');
				if (this.page.PAGE < this.loadParams.totalPage) {
					this.page.PAGE++
					this.getBusiness()
				} else {
					this.loadParams.isDone = true
				}
			},
			reset() {
				this.loadParams = {
					total: 0,
					totalPage: 1,
					isDone: false,
					isRefresh: false
				}
				this.page.PAGE = 1
				this.lists = []
			},
			search() {
				this.reset()
				this.getBusiness(true)
			},
			bindPickerChange(e) {
				console.log('picker发送选择改变，携带值为', e.detail.value)
				this.index = e.detail.value
			},
			handleClick(e, content, index) {
				console.log('click当前索引：', e, content, index);
			},
			selectGroupClient() {
				uni.navigateTo({
					url: `/pages/select-group-client/select-group-client?from=selectBusiness&mode=&index=`
				});
			},
			handleChecked(e, item, index) {
				console.log('当前索引：', e, index);
				this.lists.forEach((cur) => {
					if (cur.ID === item.ID) {
						cur.checked = !cur.checked
					} else {
						cur.checked = false
					}
				})

				if (item.checked === true) {
					// this.selectedBusiness.push(item)
					this.selectedBusiness = item
				} else {
					// const selectIndex = this.selectedBusiness.findIndex((saleplan)=>{
					// 	return saleplan.id === item.id
					// })
					// this.selectedBusiness.splice(selectIndex,1)
					this.selectedBusiness = {}
				}
			},
		}
	}
</script>

<style lang="scss" scoped>
	.view {
		flex-direction: column;
	}

	.header-bg {
		height: 284rpx;
		margin-top: -88rpx;
	}

	.header-bg-img {
		width: 750rpx;
	}

	.lists {
		position: relative;
		flex-direction: column;
		overflow-y: scroll;
		background: #f0f4f5;
		overflow-x: hidden;
		height: 100vh;
	}

	.main {
		position: relative;
		flex-direction: column;
		margin-top: -164rpx;
		padding: 0 16rpx;
	}

	.middle {
		background-color: #fff;
		border-radius: 16rpx;
		padding: 32rpx 64rpx 32rpx 48rpx;
	}

	.text-block {
		display: flex;
		overflow: hidden;
		height: 96rpx;
		margin-bottom: 14rpx;
		border-bottom: 1px solid #f4f5f6;
	}

	.text-block-last {
		margin-bottom: 0;
		border-bottom: 0;
	}

	.middle-date {
		flex: 2;
		font-size: 28rpx;
		line-height: 96rpx;
		color: #333;
		margin-bottom: 8rpx;
	}

	.middle-date-des {
		flex: 3;
		font-size: 28rpx;
		line-height: 96rpx;
		height: 96rpx;
		white-space: nowrap;
		overflow: hidden;
		text-overflow: ellipsis;
		color: #888;
	}


	.middle-date-select {
		color: #888;
	}

	.middle-date-des-select {
		color: #333;
	}

	.picker-year {
		position: relative;
		border-radius: 4px;
		align-items: center;
	}

	.uni-list-cell {
		flex: 1;
	}

	.uni-list-cell-db {
		flex: 1;
	}

	.picker-block {
		flex: 1;
	}

	.icon-arrow {
		position: absolute;
		right: 0;
		top: 16px;
		width: 12rpx;
		height: 20rpx;
		z-index: 10;
	}

	.planout-block-lists {
		display: flex;
		flex-direction: column;
		overflow: hidden;
	}

	.uni-swipe {
		flex: 1;
		margin-bottom: 26rpx;
	}

	/deep/ .uni-swipe_box {
		flex: 1;
	}

	.swipe-right-block {
		display: flex;
		width: 100rpx;
		justify-content: center;
		align-items: center;
	}

	.swipe-right-block__text {
		display: inline-block;
		width: 52rpx;
		height: 52rpx;
		border-radius: 50%;
		background-color: #fff;
	}

	.swipe-right-block__active {
		width: 52rpx;
		height: 52rpx;
		border-radius: 50%;
		background-color: $wly-primary-color;
	}

	.planout-block {
		display: flex;
		justify-content: space-between;
		height: 84rpx;
		margin-top: 64rpx;
		margin-bottom: 48rpx;
		padding: 0 24rpx;
	}

	.planout-block-item {
		flex: 1;
		width: 750rpx;
	}

	.btn {
		flex: 1;
		height: 92rpx;
		background: $wly-primary-color;
		border-radius: 46rpx;
	}

	.btn-text {
		color: #fff;
		font-size: 34rpx;
	}
</style>
